/*
 *  MoCxConduit.c
 *  MoCxConduit
 *
 *  Created by Daniel Braun on 12/03/05.
 *  Copyright 2005 __MyCompanyName__. All rights reserved.
 *
 * we really dont do C++ here, but Palm headers require c++
 *
 */

#include <unistd.h>
#include <sys/types.h>
#include <sys/un.h>
#include <sys/socket.h>
#include <sys/select.h>



#include "SyncMgr.h"
#include "UserMgr.h"
#include "hslog.h"
#include "cfmglue.h"

#include "MoCxConduit.h"

#define _IN_PROXY
#define _LOGSYNC
#include "syncproxy.h"

DWORD	GetConduitVersion(void)
{
	//system("touch /tmp/totoV");
	return kMoCxConduitVersionDef;
}


long CopyConduitNameAsCFStringRef( CFStringRef* oConduitName )
{
	*oConduitName = CFSTR("MoCroix Conduit");
	//system("touch /tmp/toto1");
	return 0;
}

long CopyActionStringAsCFStringRef(CSyncPreference& inSyncPrefs, CFStringRef* pActionString)
{
	*pActionString=CFSTR("MoCx conduit - (no pref)\n");
#if 0
	int rc;
	UmUserSyncAction syncAction=0;
	
	//system("touch /tmp/toto3");
	CfmGmlueGetHotSyncLib();

	rc=UmGetUserPermSyncPreferences (kCurrentPalmUserID, kMoCxConduitCreatorDef, &syncAction);
	if (rc == kUserMgrNoErr) {
		//system("touch /tmp/toto3b");
		switch (syncAction) {
			case kUmDoNothing:
				*pActionString=CFSTR("disabled");
				break;
			case kUmPCToHH:
				*pActionString=CFSTR("la grille du jour");
				break;
			case kUmCustom:
				*pActionString=CFSTR("MacMoCroix");
				break;
			default:
				FILE *F=fopen("/tmp/toto3bi","a");
				fprintf(F, "str action invalid action %d (%d)\n", syncAction, inSyncPrefs.m_SyncType);
				fclose(F);
				*pActionString=CFSTR("(invalid conf)");
		}
	} else {
		FILE *F=fopen("/tmp/toto3be","w");
		fprintf(F, "MoCx conduit - (no pref %d)\n", rc);
		fclose(F);
		*pActionString=CFSTR("MoCx conduit - (no pref)\n");
	}
#endif
	return 0;
}


const short kOKButton = 1;
const short kCancelButton = 2;
const short kRadioGroup = 4;
const short kDirectSynchroRadio = 5;
const short kProxySynchroRadio = 6;
const short kDoNothingRadio = 7;

/*
 * configure conduit part.
 * runs the UI for configuration. Mostly copy-pasted from
 * several examples (palm cdk) with very little understanding
 */

long ConfigureConduit( CSyncPreference& inSyncPrefs )
{
	return 0; // disabled : UmGetUserPermSyncPreferences seems not ok ?
#if 0
	CFBundleRef		bundleRef;
	OSStatus		err;
	SInt16			nonLocalizedRsrcFileRefNum = -1;
	SInt16			localizedRsrcFileRefNum = -1;
	ControlRef		radioGroup;
	DialogItemIndex 	itemHit = 0;
	DialogPtr		theDialog;
	ModalFilterUPP		filter;
	short a=0;
	UmUserSyncAction	syncAction=0;
	short b=0;

	system("touch /tmp/toto4");
	FILE *F=fopen("/tmp/toto3bi","a"); setlinebuf(F);
	
	CfmGmlueGetHotSyncLib();
	bundleRef = CFBundleGetBundleWithIdentifier( kMoCxConduitDomain );
	if (!bundleRef)	goto exit;
	err = CFBundleOpenBundleResourceFiles( bundleRef, &nonLocalizedRsrcFileRefNum, &localizedRsrcFileRefNum );
	if (err != noErr) goto exit;	
	
	GetStdFilterProc( &filter );
	
	theDialog = ::GetNewDialog(rSettingsDialog, nil, WindowPtr(-1));
	if (!theDialog) goto exit;

	
	SetDialogDefaultItem( theDialog, kOKButton );
	SetDialogCancelItem( theDialog, kCancelButton );
	
	GetDialogItemAsControl( theDialog, kRadioGroup, &radioGroup );

	UmGetUserPermSyncPreferences (kCurrentPalmUserID, kMoCxConduitCreatorDef, &syncAction) ;

	switch (syncAction) {
		case kUmDoNothing:
			SetControlValue(radioGroup, kDoNothingRadio - kRadioGroup );
			break;
		case kUmPCToHH:
			SetControlValue(radioGroup, kDirectSynchroRadio - kRadioGroup );
			break;
		case kUmCustom:
			SetControlValue(radioGroup, kProxySynchroRadio - kRadioGroup );
			break;
		default:
			fprintf(F, "conf init action invalid action %d %d %d\n", syncAction, a,b);
			syncAction=kUmDoNothing;
			SetControlValue(radioGroup, kDoNothingRadio - kRadioGroup );
			break;
	}
	
	ShowSheetWindow(GetDialogWindow(theDialog), FrontWindow() );
	for (;;) {
		int rad;
		ModalDialog(filter, &itemHit);
		
		rad= GetControlValue( radioGroup );
		fprintf(F, "rad %d item %d\n", rad, itemHit);
		switch ( rad ) {
			case kDoNothingRadio - kRadioGroup:
				syncAction = kUmDoNothing;
				break;
			case kDirectSynchroRadio - kRadioGroup:
				syncAction = kUmPCToHH;
				break;
			case kProxySynchroRadio - kRadioGroup:
				syncAction = kUmCustom;
				break;
			default:
				
				fprintf(F, "conf conf action invalid action %d (%d-%d)\n", syncAction,
					 rad,kRadioGroup );
				fclose(F);
				syncAction=kUmDoNothing;
				break;
		}
		if ((itemHit == kOKButton) || (itemHit == kCancelButton)) {
			break;
		}
	} 
	HideSheetWindow(GetDialogWindow(theDialog));
	
	::HideSheetWindow( ::GetDialogWindow(theDialog) );

	if ( itemHit == kOKButton ) {
		err=UmSetUserPermSyncPreferences (kCurrentPalmUserID, kMoCxConduitCreatorDef, syncAction) ;
		fprintf(F, "action set to %d err %d (%X)\n", syncAction,err,err);
	}

	DisposeDialog(theDialog);	
	
exit:
	if ( localizedRsrcFileRefNum != -1 ) CFBundleCloseBundleResourceMap(bundleRef, localizedRsrcFileRefNum);
	if ( nonLocalizedRsrcFileRefNum != -1 ) CFBundleCloseBundleResourceMap(bundleRef, nonLocalizedRsrcFileRefNum);
	// CfmGlueFreeHotSyncLib(); keep it no good reason to release it
	return 0;
#endif
}

static CONDHANDLE handle=0;

static int debug=0;

/*
 * real jobs start here : direct synchro
 * get a grille on www.lemonde.fr and give it to MoCx on handle
 * Warning : connection timeout ??
 */

static int MoCxDirectSynchro(FILE *F)
{
	char retdat[64];
	char data[1024*16];
	char *p;
	int len;
	CCallModuleParams params;	
	int rc;
	char szTmp[256];
	
	CFURLRef url;
	CFHTTPMessageRef myRequest;
	CFReadStreamRef fStream;
	Boolean success;
	
#define ERROR(_msg, _v) do {				\
	char szErrTmp[256];				\
	sprintf(szErrTmp,"error in " _msg " (%d)", _v);	\
	LogAddEntry(szErrTmp, slWarning, 0);		\
	goto failure;					\
} while (0)

	/*
	 * get message using CF api. Cocoa has a *much* nicer api
	 * for this, but i dont risk mixing cfm lib and cocoa
	 */
	url=CFURLCreateWithString(kCFAllocatorDefault, 
				 CFSTR("http://www.lemonde.fr/s/mots_croises/french.txt"),
				 NULL);
	myRequest = CFHTTPMessageCreateRequest(kCFAllocatorDefault, 
					CFSTR("GET"), 
					url, 
					kCFHTTPVersion1_1);
	if (!myRequest) ERROR("building request", 0);
	LogAddEntry("connecting to www.lemonde.fr",slText,0);
	
	fStream = CFReadStreamCreateForHTTPRequest(kCFAllocatorDefault,myRequest);
	if (!fStream) ERROR("building stream",0);
	//CFHTTPReadStreamSetRedirectsAutomatically(fStream, 1);
	CFReadStreamSetProperty(fStream, kCFStreamPropertyHTTPShouldAutoredirect, kCFBooleanTrue);
	success = CFReadStreamOpen( fStream );
	if (!success) ERROR("opening stream",0);
	for (p=data, len=0;;) {
		rc=CFReadStreamRead(fStream, (UInt8*) p, sizeof(data)-len);
		sprintf(szTmp, "received %d bytes", rc);
		LogAddEntry(szTmp, slText,0);
		if (rc<0) {
			ERROR("reading reply",rc);
		}
		if (!rc) break;
		len+=rc;
		p+=rc;
		if (len>=(int)sizeof(data)) ERROR("too long reply", rc); 
	}
	if (!len) ERROR("null reply", rc);
	CFReadStreamClose(fStream);
	CFRelease(myRequest);
	
	data[len]='\0';
	sprintf(szTmp, "grille %d (%d) bytes", len, rc);
	LogAddEntry(szTmp, slText,0);
		
	// Prepare call parameters 
	memset(&params, sizeof(CCallModuleParams), 0);
	params.m_dwCreatorID		= 'MoCx';
	params.m_dwTypeID		= 'appl';
	params.m_wActionCode		= 0;
	params.m_dwParamSize		= len+1;
	params.m_pParam			= (void *) data;
	params.m_dwResultBufSize	= 64;
	params.m_pResultBuf		= (void *)retdat;
	params.m_dwResultCode		= 0;
	params.m_dwActResultSize	= 0;
		
	// Send text to HH
	rc = SyncCallRemoteModule(&params);
	retdat[63]='\0';
	if (F) fprintf(F, "SyncCall rc=0x%X ret=\"%s\" %2.2X %2.2X %2.2X %2.2X %2.2X...\n", rc,
			retdat,
			retdat[0],
			retdat[1],
			retdat[2],
			retdat[3],
			retdat[4]);
	return 0;
failure:
	return -1;
}

/*
 * second option : launch MacMoCroix that will do the job
 * this should evolve to a more complete proxy, launching any application
 */
static int ProxySynchro(FILE *F)
{
	int s=0;
	int count;
	int rc;
	struct sockaddr_un sun;
	struct sockaddr_un rem;
	int remlen;
	char szTmp[256];
	char *p;
	int i;
	int soclen;
	OSStatus oss;
	LSLaunchURLSpec launch;
	CFURLRef socURL;
	CFArrayRef arRef;
	CFURLRef appURL;
	fd_set rfd;
	struct timeval timeout;
	
	p=szTmp;
	p+=sprintf(szTmp,"hotsync://");
	sprintf(p, "/tmp/proxy.hotsync.%d.%d", getuid(), getpid());
	unlink(p);
	if (1) { char szMsg[256]; sprintf(szMsg, "url <%s>", szTmp);
		LogAddEntry(szMsg, slText,0);
	}
	s=socket(AF_UNIX, SOCK_STREAM, 0);
	if (s<0) ERROR("socket", errno);
	memset(&sun, 0, sizeof(sun));
	sun.sun_family=AF_UNIX;
	strcpy(sun.sun_path, p);
	sun.sun_len=strlen(p);
	rc=bind(s, (sockaddr *)&sun, sizeof(sun));
	if (rc<0) ERROR("bind", errno);
	rc=listen(s,5);
	if (rc<0) ERROR("listen", errno);
	
	memset(&launch, 0, sizeof(launch));
	i=0;
	/* find MacMoCroix */
#define POSS do { \
	char szMsg[256]; \
	sprintf(szMsg, "not found %d", (int)oss); \
	LogAddEntry(szMsg, slText, 0); \
} while (0)

	oss=-1;
	if (oss) {POSS;oss=LSFindApplicationForInfo(kLSUnknownCreator, NULL, CFSTR("fr.braun.daniel.macmocroix"), NULL,  &appURL);i++;}
	if (oss) {POSS;oss=LSFindApplicationForInfo(kLSUnknownCreator, CFSTR("fr.braun.daniel.macmocroix"),NULL, NULL,  &appURL);i++;}
	if (oss) {POSS;oss=LSFindApplicationForInfo(kLSUnknownCreator, NULL, CFSTR("MacMoCroix"), NULL,  &appURL); i++;}
	if (oss) {POSS;oss=LSFindApplicationForInfo(kLSUnknownCreator, NULL, CFSTR("MacMoCroix.app"), NULL,  &appURL); i++;}
	if (oss) {POSS;oss=LSFindApplicationForInfo('MoCx', NULL, NULL, NULL,  &appURL); i++;}
	if (oss) {POSS;oss=LSFindApplicationForInfo(kLSUnknownCreator, NULL, CFSTR("/Applications/MacMoCroix"),NULL, &appURL);i++;}
	if (oss) {POSS;oss=LSFindApplicationForInfo(kLSUnknownCreator, NULL, CFSTR("/Applications/MacMoCroix.app"),NULL, &appURL);i++;}
	if (oss) {POSS;oss=LSFindApplicationForInfo(kLSUnknownCreator, NULL, CFSTR("Applications:MacMoCroix"),NULL, &appURL);i++;}
	if (oss) {POSS;oss=LSFindApplicationForInfo(kLSUnknownCreator, NULL, CFSTR("Applications:MacMoCroix.app"),NULL, &appURL);i++;}


	
	if (oss) ERROR("MacMoCroix not found", (int)oss);
	if (1) {
		char msg[256];
		sprintf(msg, "found step %d", i);
		LogAddEntry(msg, slText, 0);
	}
	
	/* launch it */
	launch.appURL=appURL;
	socURL = CFURLCreateWithString(kCFAllocatorDefault, 
				       CFStringCreateWithCString(kCFAllocatorDefault, szTmp, kCFStringEncodingASCII),
				       NULL);
	arRef=CFArrayCreate(kCFAllocatorDefault, (const void**)&socURL, 1, NULL);
	launch.launchFlags=kLSLaunchDontAddToRecents;//kLSLaunchDefaults
	launch.itemURLs=arRef;
	oss = LSOpenFromURLSpec ( &launch , NULL );
	CFRelease(appURL);
	CFRelease(socURL);
	CFRelease(arRef);
	if (oss) ERROR("LSOpenFromURLSpec", (int)oss);
	soclen=sizeof(rem);

	/* wait for connexion from MacMoCroix */
reselect:
	FD_ZERO(&rfd);
	FD_SET(s, &rfd);
	timeout.tv_sec=10;
	timeout.tv_usec=0;
	rc=select(s+1,&rfd, NULL,&rfd, &timeout);
	if (rc<0) {
		if (EINTR==errno) goto reselect;
		ERROR("select", errno);
	}
	if (!rc) ERROR("MacMoCroix did not connect", s);
	remlen=sizeof(rem);
	rc=accept(s, (sockaddr *)&rem, &remlen);
	if (rc<0) ERROR("accept", errno);
	close(s);
	s=rc;

	if (1) { 
		char szMsg[256]; 
		sprintf(szMsg, "connected soc=%d", s);
		LogAddEntry(szMsg, slText, 1);
	}

	/* process application commands. currently only SYNC_PROXY_REMOTEAPP */
	for (count=0;;count++) {
		CCallModuleParams callparams;
		struct syncproxy_callparam *pc;
		struct syncproxy_version *pv;
		int endcnx=0;

		char buffer[1024*64];
		char retdat[64];
		/* blocking read here, and no timeout. This is ok on conduit side,
		 */
		rc=hotsync_recv(s, buffer, sizeof(buffer));
		if (1) {
			char szMsg[256]; 
			sprintf(szMsg, "recv rc=%d errno=%d", rc, errno);
			LogAddEntry(szMsg, slText, 1);
		}
		if (rc<=0) break;
		switch (((struct syncproxy_any *)buffer)->code) {
			case SYNC_PROXY_END:
				LogAddEntry("SYNC_PROXY_END", slText, 1);
				endcnx=1;
				break;
			case SYNC_PROXY_VERSION:
				pv=(struct syncproxy_version *) buffer;
				if (pv->tid) {
					struct syncproxy_result *r;
					r=(struct syncproxy_result *)calloc(1, sizeof(syncproxy_result)+callparams.m_dwActResultSize);
					r->tid=pv->tid;
					r->rc=(pv->minproxyversion > SYNC_PROXY_VERSION_VALUE) ? 1 : 0;
					r->rc2=SYNC_PROXY_VERSION_VALUE;
					r->code=SYNC_PROXY_VERSION;
					rc=hotsync_send(s, (char *)r, sizeof(syncproxy_result));
					if (rc<0) endcnx=1;
					if (pv->minproxyversion > SYNC_PROXY_VERSION_VALUE) endcnx=1;
				}
				break;
			case SYNC_PROXY_REMOTEAPP:
				pc=(struct syncproxy_callparam *) buffer;
				// Prepare call parameters 
				memset(&callparams, sizeof(CCallModuleParams), 0);
				callparams.m_dwCreatorID=pc->creatorid;
				callparams.m_dwTypeID=pc->typid;
				callparams.m_wActionCode = pc->actioncode;
				callparams.m_dwParamSize = rc-sizeof(struct syncproxy_callparam);
				callparams.m_pParam	= pc->data;
				callparams.m_dwResultBufSize	= 64;
				callparams.m_pResultBuf		= (void *)retdat;
				callparams.m_dwResultCode		= 0;
				callparams.m_dwActResultSize	= 0;
				
				// Send text to HH
				rc = SyncCallRemoteModule(&callparams);
				retdat[63]='\0';
				if (F) fprintf(F, "SyncCall rc=0x%X ret=\"%s\" %2.2X %2.2X %2.2X %2.2X %2.2X...\n", rc,
					       retdat,
					       retdat[0],
					       retdat[1],
					       retdat[2],
					       retdat[3],
					       retdat[4]);
				if (pc->tid) {
					struct syncproxy_result *r;
					r=(struct syncproxy_result *)calloc(1, sizeof(syncproxy_result)+callparams.m_dwActResultSize);
					r->code=SYNC_PROXY_RESULT;
					r->tid=pc->tid;
					r->rc=rc;
					r->rc2=callparams.m_dwResultCode;
					memcpy(r->data, retdat, callparams.m_dwActResultSize);
					rc=hotsync_send(s, (char *)r, 
						  sizeof(syncproxy_result)+callparams.m_dwActResultSize);
					if (rc<0) endcnx=1;
				}
				break;
			default:
				ERROR("bad proxy code",((struct syncproxy_any *)buffer)->code);
				break;
		}
		if (endcnx) break;
	}
	if (1) { 
		char szMsg[256]; 
		sprintf(szMsg, "closed rc=%d errno=%d", rc, errno);
		LogAddEntry(szMsg, slText, 1);
	}
	unlink(p);
	close(s);
	return 0;
failure:
	if (s) {
		close(s);
	}
	unlink(p);
	return -1;
}

long OpenConduitCarbon(PROGRESSFNCARBON inProgressCallBack, CSyncProperties& inSyncProperties)
{
	FILE *F=NULL; // debug output to a file
	long rc;
	//CONDHANDLE h;
	if (debug) {
		F=fopen("/tmp/totoOpen", "w");
		setlinebuf(F);
	}
	rc=CfmGmlueGetHotSyncLib();
	if (rc) {
		if (F) fprintf(F,"CfmGmlueGetHotSyncLib rc=%d\n", rc);
		return rc;
	}
	rc=SyncRegisterConduit(handle);
	if (F) fprintf(F, "SyncRegisterConduit rc=0x%X, h=%0x%X\n", rc, handle);
	LogAddEntry("hello !!!!", slText, 0);
	rc=ProxySynchro(F);
	if (1 && (rc<0)) {
		LogAddEntry("proxy synchro failed, doing direct synchro", slText, 0);
		MoCxDirectSynchro(F);
	}
	rc=SyncUnRegisterConduit(handle);
	if (F) fprintf(F, "unregister rc=%X\n", rc);
	CfmGlueFreeHotSyncLib();
	if (F) fprintf(F, "all done\n");
	return 0;
}

